// adapted from "https://github.com/anselm/aframe-jsonloader-component" by Anselm Hook
if (typeof AFRAME === 'undefined')
{
	throw new Error('Component attempted to register before AFRAME was available.');
}

///
/// Load a JSON Scene for A-Frame
///
AFRAME.registerComponent('scenejson',
{
	schema:
		{ url: {type: 'string', default: "assets/scene/default.json" }},
	multiple: false,
	init: function()
	{
		let data = this.data;
		let el = this.el;
		let callback = function(json)
		{
			let id_scene=Object.keys(json)[0];
			let l_scene =Object.keys(json[id_scene]).length;
			console.log('scene',id_scene,'contains',l_scene,' Elements');
			let a_keys_scene=Object.keys(json[id_scene]);
			for(let i = 0; i < l_scene ; i++)
			{
				let id=a_keys_scene[i]; 
				let prim=Object.keys(json[id_scene][id])[0];
				let r=json[id_scene][id][prim];
				console.log(i,prim,id,'=',r);
				let e = document.createElement(prim);
				e.setAttribute('id',id)
				Object.keys(r).forEach(function(key){e.setAttribute(key,r[key]);});
				el.appendChild(e);
			}
		};
		console.log('fetch',data.url);
		fetch(data.url)
			.then(response => response.json())
			.then(json => callback(json));
	}
});

